#ifndef __exsortfiltermodel__
#define __exsortfiltermodel__

#include <QSortFilterProxyModel>

class ExSortFilterModelPrivate;

class ExSortFilterModel : public QSortFilterProxyModel {
	Q_OBJECT
private:
	mutable ExSortFilterModel * _this;

public:
	ExSortFilterModel( QObject * parent=0 );
	~ExSortFilterModel();

protected:
	virtual bool rowDataAccept( ExSortFilterModelPrivate & p, QString filterstring, QVariant fielddata ) const;

private:
	bool filterAcceptsRow( int source_row, const QModelIndex & source_parent ) const;

	void emit_syntaxError( int columnNo );

signals:
	void syntaxError( int columnNo );

friend class ExSortFilterModelPrivate;
};

#endif/*__exsortfiltermodel__*/
