#ifndef __modelfilterwidget__
#define __modelfilterwidget__

#include <QtGui/QWidget>
#include <QtCore/QList>
#include <QtCore/QStringList>
#include <QtDesigner/QDesignerExportWidget>

class QLineEdit;
class QScrollBar;
class QHeaderView;
class QAbstractItemView;
class QAbstractItemModel;

class QDESIGNER_WIDGET_EXPORT ModelFilterWidget : public QWidget {
	Q_OBJECT
	Q_PROPERTY( QString filterString READ filterString WRITE setFilterString )
private:
	QList<QLineEdit*> p_editorList;
	QScrollBar * p_viewportScrollBar;
	QHeaderView * p_header, * additionalheader;
	QAbstractItemView * p_itemView;

public:
	ModelFilterWidget( QWidget * parent=0 );
	~ModelFilterWidget();

	QAbstractItemView * itemView();

	QStringList filterStrings();
	QString filterString();

	QList<QLineEdit*> editors();


public slots:
	void setFilterString( QString str );
	void setFilterStrings( QStringList str );
	void setItemView( QAbstractItemView * itemview );

	void update();

private:
	void resizeEvent( QResizeEvent * );
	void paintEvent( QPaintEvent * );

private slots:
	void textChanged( QString );

	void resizeSections( int v=-1 );
	void sectionMoved( int logicalindex, int oldvisualindex, int newvisualindex );
	void sectionResized( int logicalindex, int oldsize, int newsize );
	void sectionCountChanged( int oldcount, int newcount );

	void setHeader( QHeaderView * header );
	void setScrollBar( QScrollBar * scrollbar );

signals:
	void filterChanged( QStringList values );
	void filterChanged( QString value );

};

#endif/*__modelfilterwidget__*/
